<?php 

	/*

		Plugin Name: Dummy Plugin
		
	*/

	class DummyPlugin {
	
		var $options_page_handle;
		
		var $options_page = 'dummy_plugin';
		var $option_group = 'dummy_plugin';
		var $option_name = 'dp_example';
		var $option_name_2 = 'dp_example_2';
		var $settings_section = 'dp_general';
	
		function __construct() {
			add_action( 'admin_init', array( &$this, 'dummy_plugin_init' ) );
			add_action( 'admin_init', array( &$this, 'test_removal' ), 11);
			add_action( 'admin_menu', array( &$this, 'add_settings_page' ) );
		}
		
		function dummy_plugin_init() {
			register_setting( $this->option_group, $this->option_name );
			register_setting( $this->option_group, $this->option_name_2 );

			add_settings_section( $this->settings_section, __( 'General Settings' ), array( &$this, 'settings_section_text' ), $this->options_page );
			
			add_settings_field( $this->option_name, __( 'Example Setting' ), array( &$this, 'settings_field_input' ), $this->options_page, $this->settings_section, array( 'type' => $this->option_name ) );
			
			add_settings_field( $this->option_name_2, __( 'Example Setting 2' ), array( &$this, 'settings_field_input' ), $this->options_page, $this->settings_section, array( 'type' => $this->option_name_2 ) );
		}
		
		function test_removal() {
			// remove_settings_field( $this->option_name, $this->option_group, $this->settings_section );
			// remove_settings_field( $this->option_name_2, $this->option_group, $this->settings_section );
			// remove_settings_section( $this->settings_section, $this->options_page );

/*
			global $wp_settings_sections, $wp_settings_fields;
			?>
				<pre><? var_dump($wp_settings_sections) ?></pre>
				<pre><? var_dump($wp_settings_fields) ?></pre>
			<?
*/
		}
		
		function add_settings_page() {
			$this->options_page_handle = add_options_page( __( 'Dummy Plugin' ), __( 'Dummy Plugin' ), 'manage_options', $this->options_page, array(  &$this, 'settings_page' ) );
		}
		
		function settings_page() {
			?>
				<div class="wrap">
					<div id="icon-options-general" class="icon32"></div>
					<h2>Dummy Plugin</h2>
					<?php if ( current_user_can( 'manage_options' ) ): ?>
						<p>This is a test of the Settings API.</p>
						<form action="options.php" method="post">
							<?php settings_fields( $this->option_group ) ?>
							<?php do_settings_sections( $this->options_page ) ?>
							<p class="submit"><input type="submit" name="submit" id="submit" class="button-primary" value="Save Changes"></p>
						</form>
					<?php else: ?>
						<p><strong>You do not have permission to be here!</strong></p>
					<?php endif ?>
				</div>
			<?php
		}
		
		function settings_section_text( $section ) {
			switch ( $section['id'] ) {
				case $this->settings_section:
					echo '<p>Some would argue that this plugin is a waste of time.</p>';
				break;
			}
		}
		
		function settings_field_input( $args = null ) {
			switch ( $args['type'] ) {
				case $this->option_name:
					$option = get_option( $this->option_name, 'Default Value' );
					echo '<input id="' . $this->option_name . '" name="' . $this->option_name . '" type="text" value="' . esc_attr( $option ) . '" />';
				break;
				case $this->option_name_2:
					$option = get_option( $this->option_name_2, 'Default Value' );
					echo '<input id="' . $this->option_name_2 . '" name="' . $this->option_name_2 . '" type="text" value="' . esc_attr( $option ) . '" />';
				break;
			}
		}
	
	}

	if ( class_exists( 'DummyPlugin' ) )
		$DummyPlugin = new DummyPlugin();

?>